// Code generated by mockery v2.20.0. DO NOT EDIT.

package mockclients

import (
	context "context"

	mock "github.com/stretchr/testify/mock"

	types "gitlab.com/infor-cloud/martian-cloud/tharsis/tharsis-sdk-go/pkg/types"
)

// Team is an autogenerated mock type for the Team type
type Team struct {
	mock.Mock
}

// AddTeamMember provides a mock function with given fields: ctx, input
func (_m *Team) AddTeamMember(ctx context.Context, input *types.AddUserToTeamInput) (*types.TeamMember, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.TeamMember
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.AddUserToTeamInput) (*types.TeamMember, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.AddUserToTeamInput) *types.TeamMember); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.TeamMember)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.AddUserToTeamInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// CreateTeam provides a mock function with given fields: ctx, input
func (_m *Team) CreateTeam(ctx context.Context, input *types.CreateTeamInput) (*types.Team, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.Team
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.CreateTeamInput) (*types.Team, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.CreateTeamInput) *types.Team); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.Team)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.CreateTeamInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

// DeleteTeam provides a mock function with given fields: ctx, input
func (_m *Team) DeleteTeam(ctx context.Context, input *types.DeleteTeamInput) error {
	ret := _m.Called(ctx, input)

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.DeleteTeamInput) error); ok {
		r0 = rf(ctx, input)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// GetTeam provides a mock function with given fields: ctx, input
func (_m *Team) GetTeam(ctx context.Context, input *types.GetTeamInput) (*types.Team, error) {
	ret := _m.Called(ctx, input)

	var r0 *types.Team
	var r1 error
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetTeamInput) (*types.Team, error)); ok {
		return rf(ctx, input)
	}
	if rf, ok := ret.Get(0).(func(context.Context, *types.GetTeamInput) *types.Team); ok {
		r0 = rf(ctx, input)
	} else {
		if ret.Get(0) != nil {
			r0 = ret.Get(0).(*types.Team)
		}
	}

	if rf, ok := ret.Get(1).(func(context.Context, *types.GetTeamInput) error); ok {
		r1 = rf(ctx, input)
	} else {
		r1 = ret.Error(1)
	}

	return r0, r1
}

type mockConstructorTestingTNewTeam interface {
	mock.TestingT
	Cleanup(func())
}

// NewTeam creates a new instance of Team. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
func NewTeam(t mockConstructorTestingTNewTeam) *Team {
	mock := &Team{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
